/////////////////////////////////////////////////////////////////////////////////////////////
//
//	This file has been created by B.Cyganek (C) 1998
//  Contains basic declarations to the Image project.
//
/////////////////////////////////////////////////////////////////////////////////////////////


#ifndef IMAGE_DECLARATIONS
#define IMAGE_DECLARATIONS


#pragma warning( disable : 4237 )


#undef min
#undef max
#include <windows.h>


/////////////////////////////////////////////////////////////////////////////////////////////


#define WIN32_LEAN_AND_MEAN


#if _DEBUG
	#define	DEBUGGING 1		 
#else
	#define	DEBUGGING 0		 
#endif

/////////////////////////////////////////////////////////////////////////////////////////////

#if	DEBUGGING

	#define _QUOTE(x) #x
	#define QUOTE(x) _QUOTE(x)

	// on REQUIRE violation exit if not IGNORE from the user
	#define REQUIRE(expr)	{																\
								if( ! (expr) )												\
								{															\
									int m;													\
									if( (m = MessageBox(NULL, 								\
											#expr "\n\n" "IN FILE: " __FILE__				\
											"\n" "IN LINE: " QUOTE(__LINE__),				\
											"Boxy\'s REQUIRE doesn\'t hold", 				\
											MB_ICONSTOP | MB_ABORTRETRYIGNORE))==IDABORT )	\
												ExitProcess((UINT)-1);						\
									else													\
										if( m == IDRETRY )									\
											DebugBreak();									\
								}															\
							}																

	#define DEBUG(string) 		MessageBox( NULL, 											\
											#string,										\
											"Boxy\'s DEBUG message", 						\
											MB_ICONINFORMATION | MB_OK);					
	
	#define INVARIANT()		if( ! this->Invariant() )										\
							{																\
								int m;														\
								if( (m = MessageBox(NULL, 									\
										"\n" "IN FILE: " __FILE__							\
										"\n" "IN LINE: " QUOTE(__LINE__),					\
										"Boxy\'s INVARIANT doesn\'t hold", 					\
										MB_ICONSTOP | MB_ABORTRETRYIGNORE))==IDABORT )		\
											ExitProcess((UINT)-1);							\
								else														\
									if( m == IDRETRY )										\
										DebugBreak();										\
							}
#else	// DEBUGGING

	#define REQUIRE(expr)	;
	#define DEBUG(string)	; 										
	#define INVARIANT()		;

#endif	// DEBUGGING





#endif IMAGE_DECLARATIONS


