// TheStack.cpp : Defines the entry point for the console application.
//

#include <iostream.h>
#include "declarations.h"		// this for REQUIRE



// ==============================================================================================



template < typename T, int MaxElems = 1000 >
class TStackFor
{
	private:

	public:

		enum { kMaxElems = MaxElems };

	protected:

		T * fData;

		int fStackPtr;		// indicates on the first free cell




	public:


		///////////////////////////////////////////////////////////
		// This function 
		///////////////////////////////////////////////////////////
		//		
		// INPUT:
		//		
		//		
		// OUTPUT:
		//		
		//		
		// REMARKS:
		//		
		//		
		TStackFor( void );

		///////////////////////////////////////////////////////////
		// This function 
		///////////////////////////////////////////////////////////
		//		
		// INPUT:
		//		
		//		
		// OUTPUT:
		//		
		//		
		// REMARKS:
		//		
		//		
		virtual ~TStackFor();


	public:

		bool Pop( T & new_elem );

		bool Push( const T & new_elem );

};


template < typename T, int MaxElems >
TStackFor< T, MaxElems >::TStackFor( void ) 
	:  fStackPtr( 0 )
{
	fData = new T[ kMaxElems ];
}

template < typename T, int MaxElems >
TStackFor< T, MaxElems >::~TStackFor() 
{
	delete [] fData;
}


template < typename T, int MaxElems >
bool TStackFor< T, MaxElems >::Pop( T & ret_elem )
{
	if( fStackPtr == 0 )
		return false;		// error, there is nothing to pop from the stack

	REQUIRE( fStackPtr < kMaxElems );
	ret_elem = fData[ -- fStackPtr ];
	return true;			// ok
}

template < typename T, int MaxElems >
bool TStackFor< T, MaxElems >::Push( const T & new_elem )
{
	REQUIRE( fStackPtr <= kMaxElems );
	if( fStackPtr >= kMaxElems )
		return false;		// error, the stack is full, no room for a new element

	fData[ fStackPtr ++ ] = new_elem;
	return true;			// ok
}


// ==============================================================================================

// Useful typedef's
typedef TStackFor< int, 1000 >	StackForInt;
typedef TStackFor< double >		StackForDouble;


// ==============================================================================================

class MyStupidClass_OnlyFor_Example_ForMyStudents
{
	private:

		int fX;
		long fY;
		double fZ;

};

typedef TStackFor< MyStupidClass_OnlyFor_Example_ForMyStudents >	AmIGoofyOrWhatStack;

// ==============================================================================================

int main(int argc, char* argv[])
{
	StackForInt theStackForInt;

	theStackForInt.Push( 2 );
	cout << "Pushed 2." << endl;
	theStackForInt.Push( 3 );
	cout << "Pushed 3." << endl << endl;

	int retElem;
	if( theStackForInt.Pop( retElem ) == true )
		cout << "The first elem is:" << retElem << endl;
	if( theStackForInt.Pop( retElem ) == true )
		cout << "The second elem is:" << retElem << endl;


	//////////////////////////////////////////////////////

	AmIGoofyOrWhatStack theAmIGoofyOrWhatStack;

	MyStupidClass_OnlyFor_Example_ForMyStudents obj_1, obj_2;

	for( int i = 0; i < 10; ++ i )
		theAmIGoofyOrWhatStack.Push( obj_1 ), theAmIGoofyOrWhatStack.Push( obj_2 );

	//////////////////////////////////////////////////////


	int x;
	cin >> x;

	return 0;
}

